scala.tools.nsc.backend.jvm

# BCodeSkelBuilder

###
Related Doc: package jvm

#### abstract class BCodeSkelBuilder extends BCodeHelpers

Source
  BCodeSkelBuilder.scala

Linear Supertypes
BCodeHelpers, BytecodeWriters, BCodeIdiomatic, SubComponent, AnyRef, Any
Known Subclasses
BCodeBodyBuilder, BCodeSyncAndTry, GenBCode, genBCode
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. BCodeSkelBuilder
2. BCodeHelpers
3. BytecodeWriters
4. BCodeIdiomatic
5. SubComponent
6. AnyRef
7. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new BCodeSkelBuilder()

### Type Members

1. #### trait AsmpBytecodeWriter extends BytecodeWriter

   Definition Classes
     BytecodeWriters

2. #### trait BCAnnotGen extends BCInnerClassGen

   Definition Classes
     BCodeHelpers

3. #### trait BCClassGen extends BCInnerClassGen

   Definition Classes
     BCodeHelpers

4. #### trait BCForwardersGen extends BCAnnotGen with BCJGenSigGen

   Definition Classes
     BCodeHelpers

5. #### trait BCInnerClassGen extends AnyRef

   Definition Classes
     BCodeHelpers

6. #### trait BCJGenSigGen extends AnyRef

   Definition Classes
     BCodeHelpers

7. #### trait BCPickles extends AnyRef

   Definition Classes
     BCodeHelpers

8. #### trait BytecodeWriter extends AnyRef

   Definition Classes
     BytecodeWriters

9. #### final class CClassWriter extends ClassWriter

   Definition Classes
     BCodeHelpers

10. #### trait ClassBytecodeWriter extends BytecodeWriter

    Definition Classes
      BytecodeWriters

11. #### class DirectToJarfileWriter extends BytecodeWriter

    Definition Classes
      BytecodeWriters

12. #### trait DumpBytecodeWriter extends BytecodeWriter

    Definition Classes
      BytecodeWriters

13. #### implicit class InsnIterInsnList extends AnyRef

    Definition Classes
      BCodeIdiomatic

14. #### implicit class InsnIterMethodNode extends AnyRef

    Definition Classes
      BCodeIdiomatic

15. #### trait JAndroidBuilder extends AnyRef

    Definition Classes
      BCodeHelpers

16. #### class JBeanInfoBuilder extends BCInnerClassGen

    Definition Classes
      BCodeHelpers

17. #### abstract class JCodeMethodN extends AnyRef

    Definition Classes
      BCodeIdiomatic

18. #### abstract class JCommonBuilder extends BCInnerClassGen with BCAnnotGen with BCForwardersGen with BCPickles

    Definition Classes
      BCodeHelpers

19. #### class JMirrorBuilder extends JCommonBuilder

    Definition Classes
      BCodeHelpers

20. #### class LabelDefsFinder extends Global.Traverser

    Definition Classes
      BCodeIdiomatic

21. #### abstract class PlainSkelBuilder extends BCClassGen with BCAnnotGen with BCInnerClassGen with JAndroidBuilder with BCForwardersGen with BCPickles with BCJGenSigGen

22. #### abstract class StdPhase extends GlobalPhase

    A standard phase template

    A standard phase template

    Definition Classes
      SubComponent

### Abstract Value Members

1. #### abstract val global: Global

   Definition Classes
     BytecodeWriters

2. #### abstract def newPhase(prev: Phase): Phase

   The phase factory

   The phase factory

   Definition Classes
     SubComponent

3. #### abstract val phaseName: String

   The name of the phase

   The name of the phase

   Definition Classes
     SubComponent

4. #### abstract val runsAfter: List[String]

   Names of phases that must run before this phase.

   Names of phases that must run before this phase.

   Definition Classes
     SubComponent

5. #### abstract val runsRightAfter: Option[String]

   Name of the phase that this phase must follow immediately.

   Name of the phase that this phase must follow immediately.

   Definition Classes
     SubComponent

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from BCodeSkelBuilder to any2stringadd[BCodeSkelBuilder] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (BCodeSkelBuilder, B)

   Implicit information
     This member is added by an implicit conversion from BCodeSkelBuilder to ArrowAssoc[BCodeSkelBuilder] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### val CLASS_CONSTRUCTOR_NAME: String

   Definition Classes
     BCodeIdiomatic

7. #### val EMPTY_BTYPE_ARRAY: Array[BTypesFromSymbols.BType]

   Definition Classes
     BCodeIdiomatic

8. #### val EMPTY_INT_ARRAY: Array[Int]

   Definition Classes
     BCodeIdiomatic

9. #### val EMPTY_LABEL_ARRAY: Array[Label]

   Definition Classes
     BCodeIdiomatic

10. #### val EMPTY_STRING_ARRAY: Array[String]

    Definition Classes
      BCodeIdiomatic

11. #### val INSTANCE_CONSTRUCTOR_NAME: String

    Definition Classes
      BCodeIdiomatic

12. #### object JCodeMethodN

    Definition Classes
      BCodeIdiomatic

13. #### val StringBuilderClassName: String

    Definition Classes
      BCodeIdiomatic

14. #### final def addInnerClassesASM(jclass: ClassVisitor, refedInnerClasses: List[BTypesFromSymbols.ClassBType]): Unit

    Definition Classes
      BCodeHelpers

15. #### final def afterOwnPhase[T](op: ⇒ T): T

    Definition Classes
      SubComponent
    Annotations
      @inline()

16. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

17. #### val bTypes: BTypesFromSymbols[global.type]

    Definition Classes
      BCodeIdiomatic

18. #### final def beforeOwnPhase[T](op: ⇒ T): T

    Definition Classes
      SubComponent
    Annotations
      @inline()

19. #### val classfileVersion: Int

    Definition Classes
      BCodeIdiomatic

20. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

21. #### final def coercionFrom(code: Int): BTypesFromSymbols.BType

    Definition Classes
      BCodeIdiomatic

22. #### final def coercionTo(code: Int): BTypesFromSymbols.BType

    Definition Classes
      BCodeIdiomatic

23. #### val emitStackMapFrame: Boolean

    Definition Classes
      BCodeIdiomatic

24. #### def enabled: Boolean

    Is this component enabled? Default is true.

    Is this component enabled? Default is true.

    Definition Classes
      SubComponent

25. #### def ensuring(cond: (BCodeSkelBuilder) ⇒ Boolean, msg: ⇒ Any): BCodeSkelBuilder

    Implicit information
      This member is added by an implicit conversion from BCodeSkelBuilder to Ensuring[BCodeSkelBuilder] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

26. #### def ensuring(cond: (BCodeSkelBuilder) ⇒ Boolean): BCodeSkelBuilder

    Implicit information
      This member is added by an implicit conversion from BCodeSkelBuilder to Ensuring[BCodeSkelBuilder] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

27. #### def ensuring(cond: Boolean, msg: ⇒ Any): BCodeSkelBuilder

    Implicit information
      This member is added by an implicit conversion from BCodeSkelBuilder to Ensuring[BCodeSkelBuilder] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

28. #### def ensuring(cond: Boolean): BCodeSkelBuilder

    Implicit information
      This member is added by an implicit conversion from BCodeSkelBuilder to Ensuring[BCodeSkelBuilder] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

29. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

30. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

31. #### val extraProc: Int

    Definition Classes
      BCodeIdiomatic

32. #### def factoryNonJarBytecodeWriter(): BytecodeWriter

    Definition Classes
      BytecodeWriters

33. #### def fieldSymbols(cls: Global.Symbol): List[Global.Symbol]

    Definition Classes
      BCodeHelpers

34. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

35. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from BCodeSkelBuilder to StringFormat[BCodeSkelBuilder] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

36. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

37. #### def getFile(sym: Global.Symbol, clsName: String, suffix: String): AbstractFile

    Definition Classes
      BytecodeWriters

38. #### def getFile(base: AbstractFile, clsName: String, suffix: String): AbstractFile

    clsName

      cls.getName

    Definition Classes
      BytecodeWriters

39. #### def getFileForClassfile(base: AbstractFile, clsName: String, suffix: String): AbstractFile

    Definition Classes
      BCodeHelpers

40. #### def getOutFolder(csym: Global.Symbol, cName: String, cunit: Global.CompilationUnit): AbstractFile

    Definition Classes
      BCodeHelpers

41. #### def hashCode(): Int

    SubComponent are added to a HashSet and two phases are the same if they have the same name

    SubComponent are added to a HashSet and two phases are the same if they have the same name

    returns

      the hash code value for this object.

    Definition Classes
      SubComponent → AnyRef → Any

42. #### def initBytecodeWriter(entryPoints: List[Global.Symbol]): BytecodeWriter

    Definition Classes
      BCodeHelpers

43. #### val initial: Boolean

    True if this phase runs before all other phases.

    True if this phase runs before all other phases. Usually, `parser`.

    Definition Classes
      SubComponent

44. #### val internal: Boolean

    True if this phase is not provided by a plug-in.

    True if this phase is not provided by a plug-in.

    Definition Classes
      SubComponent

45. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

46. #### object isJavaEntryPoint

    Definition Classes
      BCodeHelpers

47. #### val majorVersion: Int

    Definition Classes
      BCodeIdiomatic

48. #### def methodSymbols(cd: Global.ClassDef): List[Global.Symbol]

    Definition Classes
      BCodeHelpers

49. #### final def mkArray(xs: List[Label]): Array[Label]

    Definition Classes
      BCodeIdiomatic

50. #### final def mkArray(xs: List[String]): Array[String]

    Definition Classes
      BCodeIdiomatic

51. #### final def mkArray(xs: List[BTypesFromSymbols.BType]): Array[BTypesFromSymbols.BType]

    Definition Classes
      BCodeIdiomatic

52. #### final def mkArrayReverse(xs: List[Int]): Array[Int]

    Definition Classes
      BCodeIdiomatic

53. #### final def mkArrayReverse(xs: List[String]): Array[String]

    Definition Classes
      BCodeIdiomatic

54. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

55. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

56. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

57. #### def outputDirectory(sym: Global.Symbol): AbstractFile

    Definition Classes
      BytecodeWriters

58. #### def ownPhase: Phase

    The phase corresponding to this subcomponent in the current compiler run

    The phase corresponding to this subcomponent in the current compiler run

    Definition Classes
      SubComponent

59. #### def phaseNewFlags: Long

    New flags defined by the phase which are not valid before

    New flags defined by the phase which are not valid before

    Definition Classes
      SubComponent

60. #### def phaseNextFlags: Long

    New flags defined by the phase which are not valid until immediately after it

    New flags defined by the phase which are not valid until immediately after it

    Definition Classes
      SubComponent

61. #### var pickledBytes: Int

    Definition Classes
      BCodeHelpers

62. #### val requires: List[String]

    Names of phases required by this component.

    Names of phases required by this component. Default is `Nil`.

    Definition Classes
      SubComponent

63. #### val runsBefore: List[String]

    Names of phases that must run after this phase.

    Names of phases that must run after this phase. Default is `Nil`.

    Definition Classes
      SubComponent

64. #### def serialVUID(csym: Global.Symbol): Option[Long]

    Definition Classes
      BCodeHelpers

65. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

66. #### val terminal: Boolean

    True if this phase runs after all other phases.

    True if this phase runs after all other phases. Usually, `terminal`.

    Definition Classes
      SubComponent

67. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

68. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

69. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

70. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

71. #### def →[B](y: B): (BCodeSkelBuilder, B)

    Implicit information
      This member is added by an implicit conversion from BCodeSkelBuilder to ArrowAssoc[BCodeSkelBuilder] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from BCodeHelpers

### Inherited from BytecodeWriters

### Inherited from BCodeIdiomatic

### Inherited from SubComponent

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from BCodeSkelBuilder to any2stringadd[BCodeSkelBuilder]

### Inherited by implicit conversion StringFormat from BCodeSkelBuilder to StringFormat[BCodeSkelBuilder]

### Inherited by implicit conversion Ensuring from BCodeSkelBuilder to Ensuring[BCodeSkelBuilder]

### Inherited by implicit conversion ArrowAssoc from BCodeSkelBuilder to ArrowAssoc[BCodeSkelBuilder]

### Ungrouped